﻿Type=Class
Version=3.71
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'WebSocket class
Sub Class_Globals
	Private ws As WebSocket
End Sub

Public Sub Initialize
	
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	ws = WebSocket1
	Main.ConnectedBrowsers.Put(Me, "")
	Update
End Sub

Public Sub Update
	For Each Id As String In Main.HardwareState.Keys
		Dim jq As JQueryElement = ws.GetElementById(Id)
		Dim state As Boolean = Main.HardwareState.GetDefault(Id, False)
		If Id.Contains("btn") Then
			Dim html As String
			If state Then html = "<b>Down</b>" Else html = "Up"
			jq.SetHtml(html)
		Else
			jq.RunMethod("toggles", Array As Object(CreateMap("on": state)))
		End If
	Next
	ws.Flush
End Sub

Private Sub WebSocket_Disconnected
	Main.ConnectedBrowsers.Remove(Me)
End Sub

Public Sub Led_Toggle(Params As Map)
	Dim kv As KeyValue
	kv.Key = Params.Get("id")
	kv.Value = Params.Get("active")
	Main.SendKeyValue(kv)
End Sub